﻿using System;
using System.Drawing;
using System.Windows.Forms;
using System.Net;

namespace MultiDevice
{

    public struct Login
    {
        public string Host_Name;
        public string MAC;
        public string User;
        public string Password;
    }

    public struct Sequenz
    {
        public string Host_Name;
        public int Pos;
    }


    public partial class Form1 : Form
    {
        UDP udp = new UDP();
        private System.Timers.Timer Receiver_Timer;
        private System.Timers.Timer PowerTimer;
        string[] pass = new string[UDP.DevNo*2];
        bool set_shown = false;
        bool show_one_time = true;
        bool power_measurement = false;
        public int instance;
        string[] Columns_Width;
        byte small_or_big_window = 0;


        Login[] log = new Login[UDP.DevNo];
        Sequenz[] sequenz = new Sequenz[UDP.DevNo];

        ToolTip tooltip1 = new ToolTip();

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            //UpgradeSettings();

            string applicationName = Environment.GetCommandLineArgs()[0];
            string exePath = System.IO.Path.Combine(Environment.CurrentDirectory, applicationName);

            //count programm starts
            instance = System.Diagnostics.Process.GetProcessesByName(System.Diagnostics.Process.GetCurrentProcess().ProcessName).Length - 1;

            this.notifyIcon1.BalloonTipTitle = "Multi Control " + (instance + 1).ToString();
            this.notifyIcon1.Text = "Multi Control " + (instance + 1).ToString();

            //allways on top
            this.TopMost = true;

            //Max. 5 instances at a time
            if (instance > 4)
            {
                MessageBox.Show("Max. 5 instances at a time!",
                                   "NET-PwrCtrl",
                                   MessageBoxButtons.OK,
                                   MessageBoxIcon.Error,
                                   MessageBoxDefaultButton.Button1);
                Application.Exit();
            }

            if (instance == 0) Location = UDP_Com.Properties.Settings.Default.Location_0;
            if (instance == 1) Location = UDP_Com.Properties.Settings.Default.Location_1;
            if (instance == 2) Location = UDP_Com.Properties.Settings.Default.Location_2;
            if (instance == 3) Location = UDP_Com.Properties.Settings.Default.Location_3;
            if (instance == 4) Location = UDP_Com.Properties.Settings.Default.Location_4;

            if (instance == 0) udp.UDPListener(UDP_Com.Properties.Settings.Default.UDP_L_0);
            if (instance == 1) udp.UDPListener(UDP_Com.Properties.Settings.Default.UDP_L_1);
            if (instance == 2) udp.UDPListener(UDP_Com.Properties.Settings.Default.UDP_L_2);
            if (instance == 3) udp.UDPListener(UDP_Com.Properties.Settings.Default.UDP_L_3);
            if (instance == 4) udp.UDPListener(UDP_Com.Properties.Settings.Default.UDP_L_4);

            //Start Timer
            Receiver_Timer = new System.Timers.Timer(100);
            Receiver_Timer.Elapsed += OnTimedEvent;
            Receiver_Timer.Enabled = true;

            PowerTimer = new System.Timers.Timer(998);
            PowerTimer.Elapsed += PowerTimedEvent;
            PowerTimer.Enabled = true;

            dataGridView1.ColumnCount = 13;
            dataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.None;
            dataGridView1.GridColor = Color.White;
            dataGridView1.Dock = DockStyle.Fill;
            dataGridView1.RowTemplate.Height = 19;
            dataGridView1.AutoSize = true;
            dataGridView1.AllowDrop = true;
            dataGridView1.ShowCellToolTips = false;

            // Set up the delays for the ToolTip.
            tooltip1.AutoPopDelay = 3000;
            tooltip1.InitialDelay = 500;
            tooltip1.ReshowDelay = 500;
            // Force the ToolTip text to be displayed whether or not the form is active.
            tooltip1.ShowAlways = true;

            if (instance == 0) Columns_Width = UDP_Com.Properties.Settings.Default.Col_Width_0.Split(',');
            if (instance == 1) Columns_Width = UDP_Com.Properties.Settings.Default.Col_Width_1.Split(',');
            if (instance == 2) Columns_Width = UDP_Com.Properties.Settings.Default.Col_Width_2.Split(',');
            if (instance == 3) Columns_Width = UDP_Com.Properties.Settings.Default.Col_Width_3.Split(',');
            if (instance == 4) Columns_Width = UDP_Com.Properties.Settings.Default.Col_Width_4.Split(',');

            dataGridView1.ColumnHeadersHeightSizeMode = DataGridViewColumnHeadersHeightSizeMode.DisableResizing;
            dataGridView1.ColumnHeadersHeight = 18;

            dataGridView1.EnableHeadersVisualStyles = false;

            DataGridViewColumn dataGridViewColumn = dataGridView1.Columns[0];
            dataGridViewColumn.HeaderCell.Style.BackColor = Color.Gray;
            dataGridViewColumn.HeaderCell.Style.ForeColor = Color.White;
            dataGridViewColumn.Name = "Multi NET-PwrCtrl " + (instance+1).ToString(); 

            dataGridView1.CellBorderStyle = DataGridViewCellBorderStyle.SingleHorizontal;

            for (byte i = 0; i < 12; i++)
            {
                dataGridView1.Columns[i].Width = Int32.Parse(Columns_Width[i]);
                dataGridView1.Columns[i].SortMode = DataGridViewColumnSortMode.NotSortable;
            }

            dataGridView1.Columns[1].Visible = false;
            dataGridView1.Columns[1].DefaultCellStyle.BackColor = Color.AliceBlue;
            dataGridView1.Columns[2].Visible = false;
            dataGridView1.Columns[3].Visible = false;
            dataGridView1.Columns[3].DefaultCellStyle.BackColor = Color.AliceBlue;
            dataGridView1.Columns[12].Visible = false;
            dataGridView1.Columns[12].Width = 22;
            dataGridView1.Columns[12].DefaultCellStyle.ForeColor = Color.DarkGray;
            dataGridView1.Columns[12].DefaultCellStyle.Font = new Font("Arial", 6);

            dataGridView1.EditMode = DataGridViewEditMode.EditOnEnter;
            dataGridView1.ReadOnly = false;

            dataGridView1.Rows.Clear();
            Show_UDP_Setting();

            //Ask all devices
            if (instance == 0) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_0 ,"wer da?");
            if (instance == 1) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_1, "wer da?");
            if (instance == 2) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_2, "wer da?");
            if (instance == 3) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_3, "wer da?");
            if (instance == 4) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_4, "wer da?");

            pictureBox_Set.BringToFront();
            textBox_Help.Visible = false;
            dataGridView1.DoubleBuffered(true);

            Read_Setting();
        }

        static void UpgradeSettings()
        {
            var assembly = System.Reflection.Assembly.GetExecutingAssembly();
            var version = assembly.GetName().Version;

            if (version.ToString() != UDP_Com.Properties.Settings.Default.ApplicationVersion)
            {
                UDP_Com.Properties.Settings.Default.Upgrade();
                UDP_Com.Properties.Settings.Default.ApplicationVersion = version.ToString();
                UDP_Com.Properties.Settings.Default.Save();
            }
        }

        private void OnTimedEvent(Object source, System.Timers.ElapsedEventArgs e)
        {
            //System.Diagnostics.Debug.WriteLine("The Elapsed event was raised at {0}", e.SignalTime);

            if (udp.Received)
            {
                udp.Received = false;
                Build_Table();
            }
        }

        private void PowerTimedEvent(Object source, System.Timers.ElapsedEventArgs e)
        {
            //System.Diagnostics.Debug.WriteLine("The Elapsed event was raised at {0}", e.SignalTime);

            if (power_measurement)
            {
                if (instance == 0) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_0, "pow");
                if (instance == 1) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_1, "pow");
                if (instance == 2) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_2, "pow");
                if (instance == 3) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_3, "pow");
                if (instance == 4) udp.Send_Ask(UDP_Com.Properties.Settings.Default.UDP_S_4, "pow");

                for (byte i = 0; i < UDP.DevNo; i++)
                {
                    if (UDP.Devices[i].Power_Measurement)
                    {
                        for (byte j = 1; j < dataGridView1.RowCount; j+=2)
                        {
                            if ((string)dataGridView1.Rows[j].Cells[0].Value == UDP.Devices[i].Host_Name)
                            {
                                Print_Power(j, i);
                                Collect_Data(j, i);
                            }
                        }
                    }
                }
            }
        }

        private void Build_Table()
        {
            dataGridView1.Invoke((MethodInvoker)delegate ()
            {
                label_err2.Visible = false;
                
                //Error User or Password false
                if (udp.NoPass != "")
                {
                    this.label_err1.Visible = true;
                    udp.NoPass = udp.NoPass.Replace(" ", string.Empty);
                    label_err1.Text = udp.NoPass + ": User/Password false!";
                    dataGridView1.Columns[7].Visible = true;
                    AutoSizeFormToDataGridView();
                    udp.NoPass = "";
                    return;
                }
                this.label_err1.Visible = false;
                this.label_err1.Text = "";

                //dataGridView1.SuspendLayout();

                //Build Table
                dataGridView1.Rows.Clear();

                Show_UDP_Setting();

                //only HOME=small window else big window
                small_or_big_window = 0;
                for (byte h = 0; h < UDP.DevNo; h++)
                    if (UDP.Devices[h].Typ != 'H') small_or_big_window++;
                if (small_or_big_window == 0)
                    for (byte h = 7; h < 12; h++)
                        dataGridView1.Columns[h].Visible = false;

                for (byte i = 0; i < UDP.DevNo + 1; i++)
                {
                    var row = i * 2 + 1;

                    if (UDP.Devices[i].Host_Name != null)// && UDP.Devices[i].Typ == 'H')
                    {
                        //set order of rows
                        var dev = i;
                        if (sequenz[i].Host_Name != null)
                        {
                            for (byte j = 0; j < sequenz.Length - 1; j++)
                            {
                                if (sequenz[i].Host_Name == UDP.Devices[j].Host_Name)
                                {
                                   dev = j;
                                   break;
                                }
                            }
                        }

                        //Build row
                        dataGridView1.Rows.Add();
                        dataGridView1.Rows[row].ReadOnly = true;
                        dataGridView1.Rows[row].Cells[0].Value = UDP.Devices[dev].Host_Name;
                        dataGridView1.Rows[row].Cells[1].Value = UDP.Devices[dev].IP;
                        dataGridView1.Rows[row].Cells[1].Style.ForeColor = Color.DarkBlue;
                        dataGridView1.Rows[row].Cells[2].Value = UDP.Devices[dev].HTTP_Port;
                        dataGridView1.Rows[row].Cells[2].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;

                        if (UDP.Devices[dev].Temperatur != -127)
                            dataGridView1.Rows[row].Cells[3].Value = UDP.Devices[dev].Temperatur+"°C";
                        else
                            dataGridView1.Rows[row].Cells[3].Value = "-";

                        //Sensor 1
                        if(UDP.Devices[dev].Sensor_1_Ready == true)
                        {
                            dataGridView1.Rows[row].Cells[3].Value += " : " + UDP.Devices[dev].Sensor_1_Temperature + "°C : ";
                            dataGridView1.Rows[row].Cells[3].Value += UDP.Devices[dev].Sensor_1_Humidity + "% : ";
                            dataGridView1.Rows[row].Cells[3].Value += UDP.Devices[dev].Sensor_1_Brightness + "lx";
                            dataGridView1.Columns[3].Width = 180;
                        }

                        dataGridView1.Rows[row].Cells[3].Style.Alignment = DataGridViewContentAlignment.MiddleRight;

                        //All Sockets
                        var sockets=8; // all another
                        if (UDP.Devices[dev].Typ == 'H') sockets = 3;   //HOME
                        if (UDP.Devices[dev].Typ == 'o' || UDP.Devices[dev].Typ == 'f') sockets = 1; //ONE,F

                        //Show sockets
                        for (byte j = 0; j < sockets; j++)
                        {
                            dataGridView1.Rows[row].Cells[4 + j].Value = UDP.Sockets[j + (dev * 8)].Socket_Name;

                            //Switch State
                            if (UDP.Sockets[j + (dev * 8)].Socket_State)
                            {
                                dataGridView1.Rows[row].Cells[4 + j].Style.BackColor = Color.LightGreen;//.FromArgb(144,238,144);
                                dataGridView1.Rows[row].Cells[4 + j].Style.ForeColor = Color.Teal;
                            }
                            else
                            {
                                dataGridView1.Rows[row].Cells[4 + j].Style.BackColor = Color.LightGray;//.FromArgb(211, 211, 211);
                                dataGridView1.Rows[row].Cells[4 + j].Style.ForeColor = Color.Gray;
                            }
                        }

                        //show ONE and Power Measurement Results
                        if (UDP.Devices[dev].Typ == 'o' || UDP.Devices[dev].Typ == 'f') // 1 socket 
                        {
                            for (byte k = 5; k < 12; k++)
                            {
                                dataGridView1.Rows[row].Cells[k].Style.ForeColor = Color.White;
                                dataGridView1.Rows[row].Cells[k].Style.BackColor = Color.White;
                            }

                            if (UDP.Devices[dev].Power_Measurement)
                            {
                                power_measurement = true;
                                Print_Power(row, dev);
                                for (byte k = 5; k < 12; k++)
                                {
                                    dataGridView1.Rows[row].Cells[k].Style.ForeColor = Color.Blue;
                                    dataGridView1.Rows[row].Cells[k].Style.BackColor = Color.AntiqueWhite;
                                }

                                dataGridView1.Columns[12].Visible = true;

                                if (UDP.Devices[dev].Save_Power_Measurement == true)
                                    dataGridView1.Rows[row].Cells[12].Style.BackColor = Color.LightGreen;
                                else
                                    dataGridView1.Rows[row].Cells[12].Style.BackColor = Color.DarkGray;
                            }
                        }

                        //Build setup row
                        dataGridView1.Rows.Add();
                        var c = dataGridView1.Rows[row + 1];

                        c.Cells[0].Style.BackColor = Color.SkyBlue;
                        c.Cells[0].Style.ForeColor = Color.SlateGray;
                        c.Cells[0].Value = "Set " + UDP.Devices[dev].Host_Name;

                        c.Cells[1].ReadOnly = true;
                        c.Cells[1].Style.BackColor = Color.LightBlue;
                        c.Cells[1].Style.ForeColor = Color.Blue;

                        c.Cells[2].ReadOnly = true;
                        c.Cells[2].Style.BackColor = Color.LightBlue;
                        c.Cells[2].Style.ForeColor = Color.Blue;

                        c.Cells[3].ReadOnly = true;
                        c.Cells[3].Style.BackColor = Color.LightBlue;
                        c.Cells[3].Style.ForeColor = Color.Blue;

                        c.Cells[4].ReadOnly = true;
                        c.Cells[4].Style.BackColor = Color.LightBlue;
                        c.Cells[4].Style.ForeColor = Color.SlateGray;
                        c.Cells[4].Value = "User";
                        c.Cells[5].Style.BackColor = Color.AliceBlue;
                        c.Cells[5].Value = UDP_Com.Properties.Settings.Default.User;

                        c.Cells[6].ReadOnly = true;
                        c.Cells[6].Style.BackColor = Color.LightBlue;
                        c.Cells[6].Style.ForeColor = Color.SlateGray;
                        c.Cells[6].Value = "Password";
                        c.Cells[7].Style.BackColor = Color.AliceBlue;
                        pass[row + 1] = UDP_Com.Properties.Settings.Default.Password;
                        c.Cells[7].Value = new String('\u2022', UDP_Com.Properties.Settings.Default.Password.ToString().Length);

                        //Saved User,Pass set
                        for (byte k = 0; k < UDP.DevNo; k++)
                        {
                            if (log[k].MAC == UDP.Devices[dev].MAC && log[k].MAC != null)
                            {
                                c.Cells[5].Value = log[k].User;
                                pass[row + 1] = log[k].Password;
                                c.Cells[7].Value = new String('\u2022', log[k].Password.ToString().Length);

                            }
                        }

                        c.Cells[8].Value = "Save";
                        c.Cells[8].ReadOnly = true;
                        c.Cells[8].Style.BackColor = Color.SkyBlue;
                        c.Cells[8].Style.ForeColor = Color.Blue;
                        c.Cells[8].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;

                        c.Cells[9].ReadOnly = true;
                        c.Cells[9].Style.BackColor = Color.LightBlue;
                        c.Cells[9].Style.ForeColor = Color.AliceBlue;
                        if (UDP.Devices[dev].XOR_USER_Password == true)
                            c.Cells[9].Value = "⌘";

                        c.Cells[10].ReadOnly = true;
                        c.Cells[10].Style.BackColor = Color.LightBlue;

                        c.Cells[11].ReadOnly = true;
                        c.Cells[11].Style.BackColor = Color.LightBlue;

                        dataGridView1.Rows[0].Visible = false;
                        dataGridView1.Rows[row + 1].Visible = false;
                    }
                    else
                    {
                        dataGridView1.Refresh();
                        AutoSizeFormToDataGridView();
                        pictureBox_Set.Visible = true;
                        //dataGridView1.ResumeLayout();
                        break;
                    }
                }
            });
        }

        private void Show_UDP_Setting()
        {
            dataGridView1.Rows.Add();
            var d = dataGridView1.Rows[0];
            d.Cells[0].Style.BackColor = ColorTranslator.FromHtml("0x7499C4");
            d.Cells[0].Style.ForeColor = Color.WhiteSmoke;
            d.Cells[0].Value = "Set UDP Port";

            d.Cells[1].ReadOnly = true;
            d.Cells[1].Style.BackColor = Color.LightSteelBlue;
            d.Cells[1].Style.ForeColor = Color.Blue;

            d.Cells[2].ReadOnly = true;
            d.Cells[2].Style.BackColor = Color.LightSteelBlue;
            d.Cells[2].Style.ForeColor = Color.Blue;

            d.Cells[3].ReadOnly = true;
            d.Cells[3].Style.BackColor = Color.LightSteelBlue;
            d.Cells[3].Style.ForeColor = Color.Blue;

            d.Cells[4].ReadOnly = true;
            d.Cells[4].Style.BackColor = Color.LightSteelBlue;
            d.Cells[4].Style.ForeColor = Color.SlateGray;
            d.Cells[4].Value = "UDP Listen";

            d.Cells[5].Style.BackColor = Color.AliceBlue;
            if (instance == 0) dataGridView1.Rows[0].Cells[5].Value = UDP_Com.Properties.Settings.Default.UDP_L_0;
            if (instance == 1) dataGridView1.Rows[0].Cells[5].Value = UDP_Com.Properties.Settings.Default.UDP_L_1;
            if (instance == 2) dataGridView1.Rows[0].Cells[5].Value = UDP_Com.Properties.Settings.Default.UDP_L_2;
            if (instance == 3) dataGridView1.Rows[0].Cells[5].Value = UDP_Com.Properties.Settings.Default.UDP_L_3;
            if (instance == 4) dataGridView1.Rows[0].Cells[5].Value = UDP_Com.Properties.Settings.Default.UDP_L_4;

            d.Cells[6].ReadOnly = true;
            d.Cells[6].Style.BackColor = Color.LightSteelBlue;
            d.Cells[6].Style.ForeColor = Color.SlateGray;
            d.Cells[6].Value = "UDP Send";

            d.Cells[7].Style.BackColor = Color.AliceBlue;
            if (instance == 0) d.Cells[7].Value = UDP_Com.Properties.Settings.Default.UDP_S_0;
            if (instance == 1) d.Cells[7].Value = UDP_Com.Properties.Settings.Default.UDP_S_1;
            if (instance == 2) d.Cells[7].Value = UDP_Com.Properties.Settings.Default.UDP_S_2;
            if (instance == 3) d.Cells[7].Value = UDP_Com.Properties.Settings.Default.UDP_S_3;
            if (instance == 4) d.Cells[7].Value = UDP_Com.Properties.Settings.Default.UDP_S_4;

            d.Cells[8].ReadOnly = true;
            d.Cells[8].Style.BackColor = ColorTranslator.FromHtml("0x7499C4");
            d.Cells[8].Style.ForeColor = Color.WhiteSmoke;
            d.Cells[8].Style.Alignment = DataGridViewContentAlignment.MiddleCenter;
            d.Cells[8].Value = "Save";

            dataGridView1.CurrentCell = dataGridView1.Rows[0].Cells[5];
            dataGridView1.Rows[0].Cells[5].Selected = true;

            pictureBox_Set.Visible = false;

            dataGridView1.Refresh();
            AutoSizeFormToDataGridView();
        }

        private void Print_Power(int row, int dev)
        {
            dataGridView1.Rows[row].Cells[5].Value = UDP.Devices[dev].VoltageRMS + " V";
            dataGridView1.Rows[row].Cells[6].Value = UDP.Devices[dev].CurrentRMS + " A";
            dataGridView1.Rows[row].Cells[7].Value = UDP.Devices[dev].LineFrequency.ToString("0.000") + " Hz";
            dataGridView1.Rows[row].Cells[8].Value = UDP.Devices[dev].ActivePower + " W";
            dataGridView1.Rows[row].Cells[9].Value = UDP.Devices[dev].ApparentPower + " VA";
            dataGridView1.Rows[row].Cells[10].Value = UDP.Devices[dev].ReactivePower + " VAR";
            dataGridView1.Rows[row].Cells[11].Value = UDP.Devices[dev].PowerFactor + " cosφ";
        }

        private void Collect_Data(int row, int dev)
        {
            if (UDP.Devices[dev].Save_Power_Measurement == true)
            {
                int pos = UDP.Devices[dev].Array_Pos;
                DateTime time = DateTime.Now;

                dataGridView1.Rows[row].Cells[12].Value = pos + 1;

                UDP.Array_Time[pos, dev] = time.ToString("dd'/'MM'/'yy HH:mm:ss");
                UDP.Array_VoltageRMS[pos, dev] = UDP.Devices[dev].VoltageRMS;
                UDP.Array_CurrentRMS[pos, dev] = UDP.Devices[dev].CurrentRMS;
                UDP.Array_LineFrequency[pos, dev] = UDP.Devices[dev].LineFrequency;
                UDP.Array_ActivePower[pos, dev] = UDP.Devices[dev].ActivePower;
                UDP.Array_ApparentPower[pos, dev] = UDP.Devices[dev].ApparentPower;
                UDP.Array_ReactivePower[pos, dev] = UDP.Devices[dev].ReactivePower;
                UDP.Array_PowerFactor[pos, dev] = UDP.Devices[dev].PowerFactor;

                UDP.Devices[dev].Array_Pos++;

                var sec = time.Ticks / 10000000;
                //dataGridView1.Rows[3].Cells[9].Value = time.Ticks / 100000;

                if (sec - UDP.Devices[dev].TimeStamp > 3599 || UDP.Devices[dev].Array_Pos > 3599)
                {
                    //PowerTimer.Enabled = false;
                    WriteCsv(dev, false);
                    //PowerTimer.Enabled = true;
                    UDP.Devices[dev].TimeStamp = time.Ticks / 10000000;
                    UDP.File_Time_Array[dev] = time.ToString("dd'-'MM'-'yyyy HH'.'mm'.'ss");
                }
            }
        }

        //Click on Table
        private void dataGridView1_CellClick(object sender, System.Windows.Forms.DataGridViewCellEventArgs e)
        {
            if (!IsValidCellAddress(e.RowIndex, e.ColumnIndex)) return;
            dataGridView1.Rows[e.RowIndex].Selected = true;

            //Save UDP Port
            if (e.ColumnIndex == 8 && e.RowIndex == 0)
            {
                var tmp = Convert.ToInt32(dataGridView1.Rows[0].Cells[5].Value);
                if (instance == 0) UDP_Com.Properties.Settings.Default.UDP_L_0 = tmp;
                if (instance == 1) UDP_Com.Properties.Settings.Default.UDP_L_1 = tmp;
                if (instance == 2) UDP_Com.Properties.Settings.Default.UDP_L_2 = tmp;
                if (instance == 3) UDP_Com.Properties.Settings.Default.UDP_L_3 = tmp;
                if (instance == 4) UDP_Com.Properties.Settings.Default.UDP_L_4 = tmp;
                tmp = Convert.ToInt32(dataGridView1.Rows[0].Cells[7].Value);
                if (instance == 0) UDP_Com.Properties.Settings.Default.UDP_S_0 = tmp;
                if (instance == 1) UDP_Com.Properties.Settings.Default.UDP_S_1 = tmp;
                if (instance == 2) UDP_Com.Properties.Settings.Default.UDP_S_2 = tmp;
                if (instance == 3) UDP_Com.Properties.Settings.Default.UDP_S_3 = tmp;
                if (instance == 4) UDP_Com.Properties.Settings.Default.UDP_S_4 = tmp;
                UDP_Com.Properties.Settings.Default.Save();
                Application.Restart();
                return;
            }

            //Save Settings
            if (e.ColumnIndex == 8 && e.RowIndex % 2 == 0)
            {
                //System.Diagnostics.Debug.WriteLine("Settings");
                dataGridView1.CurrentCell = dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex];
                dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor = Color.LawnGreen;
                dataGridView1.Refresh();
                Save_Setting();
            }

            //More information
            if (e.ColumnIndex == 0)
            {
                dataGridView1.Columns[1].Visible = !dataGridView1.Columns[1].Visible;
                dataGridView1.Columns[2].Visible = !dataGridView1.Columns[2].Visible;
                dataGridView1.Columns[3].Visible = !dataGridView1.Columns[3].Visible;
                AutoSizeFormToDataGridView();
            }

            //Start browser with IP
            if (e.ColumnIndex == 1) {
                string target = "http://"
                    + (string)dataGridView1.Rows[e.RowIndex + 1].Cells[5].Value + ":" 
                    + pass[e.RowIndex + 1] + "@" 
                    + dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value + ":" 
                    + dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex+1].Value;
                System.Diagnostics.Process.Start(target);
            }

            if (e.ColumnIndex < 4) return;
            if (dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor == Color.Empty) return;

            //Switch
            var ip = (IPAddress)dataGridView1.Rows[e.RowIndex].Cells[1].Value;

            int port = 0;
            if (instance == 0) port = UDP_Com.Properties.Settings.Default.UDP_S_0;
            if (instance == 1) port = UDP_Com.Properties.Settings.Default.UDP_S_1;
            if (instance == 2) port = UDP_Com.Properties.Settings.Default.UDP_S_2;
            if (instance == 3) port = UDP_Com.Properties.Settings.Default.UDP_S_3;
            if (instance == 4) port = UDP_Com.Properties.Settings.Default.UDP_S_4;

            if (dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor == Color.LightGreen)
            {
                udp.Switch(port, ip, "Sw_off", e.ColumnIndex - 3,
                    (string)dataGridView1.Rows[e.RowIndex + 1].Cells[5].Value,
                    pass[e.RowIndex + 1], (string)dataGridView1.Rows[e.RowIndex + 1].Cells[9].Value);
            }

            if (dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor == Color.LightGray)
            {
                udp.Switch(port, ip, "Sw_on", e.ColumnIndex - 3,
                   (string)dataGridView1.Rows[e.RowIndex + 1].Cells[5].Value,
                    pass[e.RowIndex + 1], (string)dataGridView1.Rows[e.RowIndex + 1].Cells[9].Value);
            }


            //Start Electric-Data collection
            if (e.ColumnIndex == 12)
            {
                if (dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor == Color.DarkGray)
                {
                    var dev = RowtoDev(e.RowIndex);
                    dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor = Color.LightGreen;
                    UDP.Devices[dev].Save_Power_Measurement = true;
                    DateTime time = DateTime.Now;
                    UDP.Devices[dev].TimeStamp = time.Ticks / 10000000;
                    UDP.File_Time_Array[dev] = time.ToString("dd'-'MM'-'yyyy HH'.'mm'.'ss");
                }
                else
                {
                    dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor = Color.DarkGray;
                    UDP.Devices[RowtoDev(e.RowIndex)].Save_Power_Measurement = false;
                    WriteCsv(e.RowIndex, true);
                }
            }
        }

        private int RowtoDev(int row)
        {
            for (byte i = 0; i < UDP.DevNo; i++)
            {
                if ((string)dataGridView1.Rows[row].Cells[0].Value == UDP.Devices[i].Host_Name)
                    return i;
            }
            return -1;
        }

        private void dataGridView1_SelectionChanged(object sender, EventArgs e)
        {
            dataGridView1.ClearSelection();
        }

        private bool IsValidCellAddress(int rowIndex, int columnIndex)
        {
            return rowIndex >= 0 && rowIndex < dataGridView1.RowCount &&
                columnIndex >= 0 && columnIndex <= dataGridView1.ColumnCount;
        }

        // Hide Form
        //-------------------------------------------------------------------------------------------------------------------------------------
        private void notifyIcon1_Click(object sender, EventArgs e)
        {
            Show();
            this.WindowState = FormWindowState.Normal;
            notifyIcon1.Visible = false;
        }

        private void pictureBox_Hide_Click(object sender, EventArgs e)
        {
            Hide();
            notifyIcon1.Visible = true;
            if (show_one_time) notifyIcon1.ShowBalloonTip(2000);
            show_one_time = false;
        }

        private void pictureBox_Hide_MouseHover(object sender, EventArgs e)
        {
            ToolTip tt = new ToolTip();
            tt.SetToolTip(this.pictureBox_Hide, "Minimize");
        }

        // Auto Size
        //-------------------------------------------------------------------------------------------------------------------------------------
        public void AutoSizeFormToDataGridView()
        {
            Size contentsSize = GetDataGridViewContentsSize();

            if (this.Height == contentsSize.Height - 30 && this.Width == contentsSize.Width - 30) return;

            this.Height = contentsSize.Height - 30;
            this.Width = contentsSize.Width - 30;
            pictureBox_Set.Location = new Point(contentsSize.Width - 100, 2);
            pictureBox_Hide.Location = new Point(contentsSize.Width - 62, 1);
            pictureBox_Close.Location = new Point(contentsSize.Width - 46, 2);
            pictureBox_Question.Location = new Point(contentsSize.Width - 82, 2);
        }

        protected Size GetDataGridViewContentsSize()
        {
            DockStyle dockStyleSave = dataGridView1.Dock;
            dataGridView1.Dock = DockStyle.None;
            Size dataContentsSize = dataGridView1.Size;
            dataGridView1.Dock = dockStyleSave;
            return dataContentsSize;
        }

        // Change Column Width
        //-------------------------------------------------------------------------------------------------------------------------------------
        private void dataGridView1_ColumnWidthChanged(object sender, DataGridViewColumnEventArgs e)
        {
            int[] value = new int[12];
            AutoSizeFormToDataGridView();

            //Save Width
            for (byte i = 0; i < 12; i++) value[i] = dataGridView1.Columns[i].Width;
            var result = string.Join(",", value);
            if (instance == 0) UDP_Com.Properties.Settings.Default.Col_Width_0 = result;
            if (instance == 1) UDP_Com.Properties.Settings.Default.Col_Width_1 = result;
            if (instance == 2) UDP_Com.Properties.Settings.Default.Col_Width_2 = result;
            if (instance == 3) UDP_Com.Properties.Settings.Default.Col_Width_3 = result;
            if (instance == 4) UDP_Com.Properties.Settings.Default.Col_Width_4 = result;
            UDP_Com.Properties.Settings.Default.Save();
        }

        // Move Window
        //-------------------------------------------------------------------------------------------------------------------------------------
        private Point m_offset;
        private Point m_Pos;
        private bool mousedown=false;

        private void dataGridView1_MouseDown(object sender, MouseEventArgs e)
        {
            DragandMove_dataGridView1_MouseDown(sender, e);

            if (dataGridView1.Cursor != Cursors.SizeWE && e.Y<20)
            {
                m_offset = new Point(-e.X, -e.Y);
                mousedown = true;
            }
        }

        private void dataGridView1_MouseUp(object sender, MouseEventArgs e)
        {
            mousedown = false;
        }

        private void dataGridView1_MouseMove(object sender, MouseEventArgs e)
        {
            DragandMove_dataGridView1_MouseMove(sender, e);

            if (e.Button == MouseButtons.Left && dataGridView1.Cursor != Cursors.SizeWE && mousedown == true)
            {
                m_Pos = Control.MousePosition;
                m_Pos.Offset(m_offset.X, m_offset.Y);
                Location = m_Pos;
            }
        }

        private void pictureBox_Close_MouseHover(object sender, EventArgs e)
        {
            ToolTip tt = new ToolTip();
            tt.SetToolTip(this.pictureBox_Close, "Close");
        }

        private void pictureBox_Question_MouseHover(object sender, EventArgs e)
        {
            ToolTip tt = new ToolTip();
            tt.SetToolTip(this.pictureBox_Question, "Help");
        }

        // Settings open
        //-------------------------------------------------------------------------------------------------------------------------------------
        private void pictureBox_Set_MouseHover(object sender, EventArgs e)
        {
            ToolTip tt = new ToolTip();
            tt.SetToolTip(this.pictureBox_Set, "Settings");
        }

        private void pictureBox_Set_Click(object sender, EventArgs e)
        {
            if (small_or_big_window == 0)
            {
                set_shown = !set_shown;

                if (set_shown)
                    for (byte h = 7; h < 9; h++)
                        dataGridView1.Columns[h].Visible = true;
                else
                    for (byte h = 7; h < 9; h++)
                        dataGridView1.Columns[h].Visible = false;
            }

            for (byte i = 0; i < dataGridView1.RowCount; i++)
            {
                string s = (string)dataGridView1.Rows[i].Cells[0].Value;
                if (s!=null)
                    if (s.Substring(0, 3) == "Set") dataGridView1.Rows[i].Visible = !dataGridView1.Rows[i].Visible;
            }
            AutoSizeFormToDataGridView();
        }

        // Settings
        //-------------------------------------------------------------------------------------------------------------------------------------
        private void Read_Setting()
        {
            string[] result = null;
            if (instance == 0) result = UDP_Com.Properties.Settings.Default.Login_0.Split(',');
            if (instance == 1) result = UDP_Com.Properties.Settings.Default.Login_1.Split(',');
            if (instance == 2) result = UDP_Com.Properties.Settings.Default.Login_2.Split(',');
            if (instance == 3) result = UDP_Com.Properties.Settings.Default.Login_3.Split(',');
            if (instance == 4) result = UDP_Com.Properties.Settings.Default.Login_4.Split(',');

            if (result.Length > 4)
            {
                for (byte i = 0; i < result.Length-4; i += 4)
                {
                    log[i / 4].MAC = result[i];
                    log[i / 4].Host_Name = result[i + 1];
                    log[i / 4].User = result[i + 2];

                    string decryptedstring = EncryptionHelper.Decrypt(result[i + 3]);

                    log[i / 4].Password = decryptedstring;
                }
            }

            string[] order = null;
            if (instance == 0) order = UDP_Com.Properties.Settings.Default.Sequenz_0.Split(',');
            if (instance == 1) order = UDP_Com.Properties.Settings.Default.Sequenz_1.Split(',');
            if (instance == 2) order = UDP_Com.Properties.Settings.Default.Sequenz_2.Split(',');
            if (instance == 3) order = UDP_Com.Properties.Settings.Default.Sequenz_3.Split(',');
            if (instance == 4) order = UDP_Com.Properties.Settings.Default.Sequenz_4.Split(',');
            //            if (order.Length > 2)
            {
                for (byte i = 0; i < order.Length-2 ; i += 2)
                {
                    sequenz[i / 2].Host_Name = order[i];
                    sequenz[i / 2].Pos = Convert.ToInt32(order[i + 1]);
                }
            }
        }

        private void Save_Setting()
        {
            Login[] value = new Login[UDP.DevNo];
            string result="";

            for (byte i = 0; i < UDP.DevNo; i++)
            {
                value[i].MAC = UDP.Devices[i].MAC;
                value[i].Host_Name = UDP.Devices[i].Host_Name;
                result += UDP.Devices[i].MAC +"," + UDP.Devices[i].Host_Name +",";

                for (byte j = 1; j < dataGridView1.RowCount; j += 2)
                    if ((string)dataGridView1.Rows[j].Cells[0].Value == UDP.Devices[i].Host_Name)
                    {
                        result += (string)dataGridView1.Rows[j+1].Cells[5].Value + ",";
                        value[i].User = (string)dataGridView1.Rows[j + 1].Cells[5].Value;

                        string s = (string)dataGridView1.Rows[j + 1].Cells[7].Value;

                        if (!s.StartsWith("\u2022"))
                        {
                            result += EncryptionHelper.Encrypt(s) + ","; 
                            value[i].Password = s;
                            pass[j + 1] = s;
                            break;
                        }
                        else
                        {
                            result += EncryptionHelper.Encrypt(pass[j + 1]) + ",";
                            value[i].Password = pass[j + 1];
                            break;
                        }
                    }
            }

            if (instance == 0) UDP_Com.Properties.Settings.Default.Login_0 = result;
            if (instance == 1) UDP_Com.Properties.Settings.Default.Login_1 = result;
            if (instance == 2) UDP_Com.Properties.Settings.Default.Login_2 = result;
            if (instance == 3) UDP_Com.Properties.Settings.Default.Login_3 = result;
            if (instance == 4) UDP_Com.Properties.Settings.Default.Login_4 = result;
            UDP_Com.Properties.Settings.Default.Save();
            System.Threading.Thread.Sleep(500);

            for (byte j = 2; j < dataGridView1.RowCount; j += 2)
            {
                dataGridView1.Rows[j].Cells[8].Style.BackColor = Color.SkyBlue;
            }

            Read_Setting();
        }

        private void Save_Sequenz()
        {
            Login[] value = new Login[UDP.DevNo];
            string result = "";

            for (byte i = 0; i < dataGridView1.RowCount/2; i++)
            {
                sequenz[i].Host_Name = (string)dataGridView1.Rows[i*2+1].Cells[0].Value;
                sequenz[i].Pos = i;
                result += sequenz[i].Host_Name + ',' + sequenz[i].Pos + ',';
            }
            if (instance == 0) UDP_Com.Properties.Settings.Default.Sequenz_0 = result;
            if (instance == 1) UDP_Com.Properties.Settings.Default.Sequenz_1 = result;
            if (instance == 2) UDP_Com.Properties.Settings.Default.Sequenz_2 = result;
            if (instance == 3) UDP_Com.Properties.Settings.Default.Sequenz_3 = result;
            if (instance == 4) UDP_Com.Properties.Settings.Default.Sequenz_4 = result;
            UDP_Com.Properties.Settings.Default.Save();
        }

        // Close
        //-------------------------------------------------------------------------------------------------------------------------------------
        private void pictureBox_Close_Click(object sender, EventArgs e)
        {

            //Save collect electrical data
            for (byte i = 0; i < UDP.DevNo; i++)
            {
                if (UDP.Devices[i].Save_Power_Measurement)
                {
                            WriteCsv(i, false);
                }
            }

            Application.Exit();
        }

        private void Form1_FormClosing(object sender, FormClosingEventArgs e)
        {

            if (instance == 0) UDP_Com.Properties.Settings.Default.Location_0 = Location;
            if (instance == 1) UDP_Com.Properties.Settings.Default.Location_1 = Location;
            if (instance == 2) UDP_Com.Properties.Settings.Default.Location_2 = Location;
            if (instance == 3) UDP_Com.Properties.Settings.Default.Location_3 = Location;
            if (instance == 4) UDP_Com.Properties.Settings.Default.Location_4 = Location;

            UDP_Com.Properties.Settings.Default.Save();
            notifyIcon1.Visible = false;
        }

        bool appNotRestarted = true;

        public void Restart()
        {
            if (appNotRestarted == true)
            {
                appNotRestarted = false;
                System.Diagnostics.Process.Start(Application.ExecutablePath);
                Application.Exit();
            }
        }

        //Drag and Move rows
        //-------------------------------------------------------------------------------------------------------------------------------------
        private Rectangle dragBoxFromMouseDown;
        private int rowIndexFromMouseDown;
        private int rowIndexOfItemUnderMouseToDrop;

        private void DragandMove_dataGridView1_MouseMove(object sender, MouseEventArgs e)
        {
            if ((e.Button & MouseButtons.Left) == MouseButtons.Left)
            {
                // If the mouse moves outside the rectangle, start the drag.
                if (dragBoxFromMouseDown != Rectangle.Empty &&
                    !dragBoxFromMouseDown.Contains(e.X, e.Y))
                {
                    // Proceed with the drag and drop, passing in the list item.                    
                    DragDropEffects dropEffect = dataGridView1.DoDragDrop(dataGridView1.Rows[rowIndexFromMouseDown], DragDropEffects.Move);
                }
            }
        }

        private void DragandMove_dataGridView1_MouseDown(object sender, MouseEventArgs e)
        {
            // Get the index of the item the mouse is below.
            rowIndexFromMouseDown = dataGridView1.HitTest(e.X, e.Y).RowIndex;

            if (rowIndexFromMouseDown % 2 == 0) return;

            if (rowIndexFromMouseDown != -1)
            {
                // Remember the point where the mouse down occurred. 
                // The DragSize indicates the size that the mouse can move 
                // before a drag event should be started.                
                Size dragSize = SystemInformation.DragSize;
                // Create a rectangle using the DragSize, with the mouse position being
                // at the center of the rectangle.
                dragBoxFromMouseDown = new Rectangle(new Point(e.X - (dragSize.Width / 2), e.Y - (dragSize.Height / 2)), dragSize);
            }
            else
            {
                // Reset the rectangle if the mouse is not over an item in the ListBox.
                dragBoxFromMouseDown = Rectangle.Empty;
            }
        }

        private void dataGridView1_DragOver(object sender, DragEventArgs e)
        {
            if (rowIndexFromMouseDown % 2 == 0) return;

            e.Effect = DragDropEffects.Move;
        }

        private void dataGridView1_DragDrop(object sender, DragEventArgs e)
        {
            // The mouse locations are relative to the screen, so they must be 
            // converted to client coordinates.
            Point clientPoint = dataGridView1.PointToClient(new Point(e.X, e.Y));
            // Get the row index of the item the mouse is below. 
            rowIndexOfItemUnderMouseToDrop = dataGridView1.HitTest(clientPoint.X, clientPoint.Y).RowIndex;
            // If the drag operation was a move then remove and insert the row.
            if (e.Effect == DragDropEffects.Move)
            {
                DataGridViewRow rowToMove = dataGridView1.Rows[rowIndexFromMouseDown];
                DataGridViewRow rowToMove1 = dataGridView1.Rows[rowIndexFromMouseDown + 1];

                if (rowIndexFromMouseDown > rowIndexOfItemUnderMouseToDrop)
                { 
                    dataGridView1.Rows.RemoveAt(rowIndexFromMouseDown);
                    dataGridView1.Rows.Insert(rowIndexOfItemUnderMouseToDrop, rowToMove);
                    dataGridView1.Rows.RemoveAt(rowIndexFromMouseDown + 1);
                    dataGridView1.Rows.Insert(rowIndexOfItemUnderMouseToDrop + 1, rowToMove1);
                }
                else
                {
                    dataGridView1.Rows.RemoveAt(rowIndexFromMouseDown + 1);
                    dataGridView1.Rows.Insert(rowIndexOfItemUnderMouseToDrop + 1, rowToMove1);
                    dataGridView1.Rows.RemoveAt(rowIndexFromMouseDown);
                    dataGridView1.Rows.Insert(rowIndexOfItemUnderMouseToDrop, rowToMove);
                }

                Save_Sequenz();
            }
        }

        //ToolTips
        //-------------------------------------------------------------------------------------------------------------------------------------
        private void dataGridView1_CellMouseEnter(object sender, DataGridViewCellEventArgs e)
        {

            if ((e.RowIndex == -1) && (e.ColumnIndex == 0))
            {
                tooltip1.SetToolTip(dataGridView1, "Click & hold" + Environment.NewLine + "to move window");
                return;
            }

            if ((e.RowIndex % 2!=0) && (e.ColumnIndex == 0))
                tooltip1.SetToolTip(dataGridView1, "Drag&Drop to reorder");

            if (e.ColumnIndex == 1)
                tooltip1.SetToolTip(dataGridView1, "Click to open" + Environment.NewLine + "in the browser");

            if (e.RowIndex > 0 && e.ColumnIndex == 12 && dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor == Color.DarkGray)
                tooltip1.SetToolTip(dataGridView1, "click to start" + Environment.NewLine + "data collection" + Environment.NewLine + "in a CSV File");

            if (e.RowIndex > 0 && e.ColumnIndex == 12 && dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Style.BackColor == Color.LightGreen)
                tooltip1.SetToolTip(dataGridView1, "click to stop" + Environment.NewLine + "and save CSV File" + Environment.NewLine + "in Download directory");

            if (e.RowIndex > 0 && e.ColumnIndex == 9 && (string)dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value == "⌘")
                tooltip1.SetToolTip(dataGridView1, "Encrypted password");

            using (Graphics g = dataGridView1.CreateGraphics())
            {
                try
                {
                    string s = (string)dataGridView1.Rows[e.RowIndex].Cells[e.ColumnIndex].Value;
                    var c = (int)g.MeasureString(s, dataGridView1.ColumnHeadersDefaultCellStyle.Font).Width;

                    if (c > dataGridView1.Columns[e.ColumnIndex].Width)
                        tooltip1.SetToolTip(dataGridView1, s);
                }
                catch { }
            }
        }

        private void dataGridView1_CellMouseLeave(object sender, DataGridViewCellEventArgs e)
        {
            tooltip1.RemoveAll();
        }

        private void pictureBox_Question_Click(object sender, EventArgs e)
        {
            textBox_Help.Visible = !textBox_Help.Visible;

            if (textBox_Help.Visible)
            {
                if (this.Height < 170)
                {
                    this.Height = 170;
                }
            }
            else
                AutoSizeFormToDataGridView();
        }

        public static string getHomePath()
        {
            if (System.Environment.OSVersion.Platform == System.PlatformID.Unix)
                return System.Environment.GetEnvironmentVariable("HOME");

            return System.Environment.ExpandEnvironmentVariables("%HOMEDRIVE%%HOMEPATH%");
        }

        public static string getDownloadFolderPath()
        {
            if (System.Environment.OSVersion.Platform == System.PlatformID.Unix)
            {
                string pathDownload = System.IO.Path.Combine(getHomePath(), "Downloads");
                return pathDownload;
            }

            return System.Convert.ToString(
                Microsoft.Win32.Registry.GetValue(
                     @"HKEY_CURRENT_USER\Software\Microsoft\Windows\CurrentVersion\Explorer\Shell Folders"
                    , "{374DE290-123F-4565-9164-39C4925E467B}"
                    , String.Empty
                )
            );
        }

        void WriteCsv(int dataGrid_row, bool RowtoDev_Conv)
        {
            // Write data to CSV file
            string path = getDownloadFolderPath();

            int dev;

            if(this.ContainsFocus) Cursor = Cursors.WaitCursor;

            if (RowtoDev_Conv == true) dev = RowtoDev(dataGrid_row); else dev = dataGrid_row;
            string time_date = UDP.File_Time_Array[dev];

            using (ReadWriteCsv.CsvFileWriter writer = new ReadWriteCsv.CsvFileWriter(path +'\\' + UDP.Devices[dev].Host_Name + ' ' + time_date + ".csv"))
            {
                ReadWriteCsv.CsvRow row = new ReadWriteCsv.CsvRow();
                row.Add("Date/Time");
                row.Add("V");
                row.Add("A");
                row.Add("Hz");
                row.Add("W");
                row.Add("VA");
                row.Add("VAR");
                row.Add("PF");
                writer.WriteRow(row);

                for (int i = 0; i < UDP.Devices[dev].Array_Pos; i++)
                {
                    ReadWriteCsv.CsvRow row_a = new ReadWriteCsv.CsvRow();

                    row_a.Add(UDP.Array_Time[i, dev]);
                    row_a.Add(UDP.Array_VoltageRMS[i, dev].ToString().Replace(',','.'));
                    row_a.Add(UDP.Array_CurrentRMS[i, dev].ToString().Replace(',', '.'));
                    row_a.Add(UDP.Array_LineFrequency[i, dev].ToString().Replace(',', '.'));
                    row_a.Add(UDP.Array_ActivePower[i, dev].ToString().Replace(',', '.'));
                    row_a.Add(UDP.Array_ApparentPower[i, dev].ToString().Replace(',', '.'));
                    row_a.Add(UDP.Array_ReactivePower[i, dev].ToString().Replace(',', '.'));
                    row_a.Add(UDP.Array_PowerFactor[i, dev].ToString().Replace(',', '.'));

                    writer.WriteRow(row_a);
                }

                UDP.Devices[dev].Array_Pos = 0;
                Array.Clear(UDP.Array_Time, 0, UDP.Array_Time.Length);
                Array.Clear(UDP.Array_VoltageRMS, 0, UDP.Array_VoltageRMS.Length);
                Array.Clear(UDP.Array_CurrentRMS, 0, UDP.Array_CurrentRMS.Length);
                Array.Clear(UDP.Array_LineFrequency, 0, UDP.Array_LineFrequency.Length);
                Array.Clear(UDP.Array_ActivePower, 0, UDP.Array_ActivePower.Length);
                Array.Clear(UDP.Array_ApparentPower, 0, UDP.Array_ApparentPower.Length);
                Array.Clear(UDP.Array_ReactivePower, 0, UDP.Array_ReactivePower.Length);
                Array.Clear(UDP.Array_PowerFactor, 0, UDP.Array_PowerFactor.Length);
            }

            if (this.ContainsFocus) Cursor = Cursors.Default;
        }

        void ReadCsv()
        {
            // Read sample data from CSV file
            using (ReadWriteCsv.CsvFileReader reader = new ReadWriteCsv.CsvFileReader("ReadTest.csv"))
            {
                ReadWriteCsv.CsvRow row = new ReadWriteCsv.CsvRow();
                while (reader.ReadRow(row))
                {
                    foreach (string s in row)
                    {
                        Console.Write(s);
                        Console.Write(" ");
                    }
                    Console.WriteLine();
                }
            }
        }

    }
}
